uniform sampler2D tex;

#pragma MSP stage(vertex)
layout(location=0) in vec4 position;
void main()
{
	out vec2 texcoord = position.xy*0.5+0.5;
	gl_Position = position;
}

#pragma MSP stage(geometry)
layout(triangles) in;
layout(triangles, max_vertices=3) out;
void main()
{
	for(int i=0; i<3; ++i)
	{
		passthrough[i];
		EmitVertex();
	}
}

#pragma MSP stage(fragment)
layout(location=0) out vec4 frag_color;
void main()
{
	frag_color = texture(tex, texcoord);
}

/* Expected output: vertex
layout(location=0) in vec4 position;
out vec2 texcoord;
void main()
{
	texcoord = position.xy*0.5+0.5;
	gl_Position = position;
}
*/

/* Expected output: geometry
layout(triangles) in;
layout(triangles, max_vertices=3) out;
in vec2 texcoord[];
out vec2 _gs_out_texcoord;
void main()
{
	for(int i = 0; i<3; ++i)
	{
		gl_Position = gl_in[i].gl_Position;
		_gs_out_texcoord = texcoord[i];
		EmitVertex();
	}
}
*/

/* Expected output: fragment
uniform sampler2D tex;
layout(location=0) out vec4 frag_color;
in vec2 _gs_out_texcoord;
void main()
{
	frag_color = texture(tex, _gs_out_texcoord);
}
*/
